{
  "index_patterns": ["{{ elasticsearch_metadata_index_name_prefix }}{{ elasticsearch_metadata_index_version }}_*", "{{ elasticsearch_metadata_index_internal_name_prefix }}{{ elasticsearch_metadata_index_version }}_*"],
  "template": {
    "settings": {
      "index": {
        "number_of_shards": "{{ elasticsearch_metadata_index_number_of_shards }}",
        "number_of_replicas": "{{ elasticsearch_metadata_index_number_of_replicas }}"
      }
    },
    "mappings" : {
      "dynamic_templates": [
        {
          "about_prefLabel": {
            "path_match": "about.prefLabel.*",
            "mapping": {
              "type": "text",
              "copy_to": "about.prefLabel_full"
            }
          }
        }
      ],
      "dynamic": "false",
      "properties" : {
        "about" : {
          "properties" : {
            "id" : {
              "type" : "keyword"
            },
            "prefLabel" : {
              "dynamic" : "true",
              "properties" : {}
            },
            "prefLabel_full": {
              "type": "text"
            }
          }
        },
        "conditionsOfAccess": {
          "properties" : {
            "type": {
              "type": "keyword"
            },
            "id" : {
              "type" : "keyword"
            },
            "prefLabel" : {
              "dynamic" : "true",
              "properties" : {}
            }
          }
        },
        "courseCode": {
          "type" : "keyword"
        },
        "coursePrerequisites": {
          "type" : "text"
        },
        "description" : {
          "properties": {
            "@value": {
              "type" : "text"
            },
            "@language": {
              "type" : "keyword"
            }
          }
        },
        "id" : {
          "type" : "keyword",
          "index": false
        },
        "image" : {
          "type" : "keyword",
          "index": false
        },
        "inLanguage" : {
          "type" : "keyword"
        },
        "isAccessibleForFree": {
          "type": "boolean"
        },
        "educationalLevel" : {
          "type" : "keyword"
        },
        "teaches" : {
          "type" : "text"
        },
        "assesses" : {
          "type" : "text"
        },
        "competencyRequired" : {
          "type" : "text"
        },
        "name" : {
          "properties": {
            "@value": {
              "type" : "text"
            },
            "@language": {
              "type" : "keyword"
            }
          }
        },
        "numberOfCredits": {
          "type": "half_float"
        },
        "mainEntityOfPage" : {
          "properties" : {
            "id" : {
              "type" : "keyword",
              "index": false
            },
            "type" : {
              "type" : "keyword"
            },
            "dateCreated" : {
              "type" : "date",
              "index" : true
            },
            "dateModified" : {
              "type" : "date",
              "index" : true
            },
            "provider" : {
              "properties" : {
                "id" : {
                  "type" : "keyword"
                },
                "type" : {
                  "type" : "keyword"
                },
                "name" : {
                  "type" : "keyword"
                }
              }
            }
          }
        },
        "sourceOrganization" : {
          "properties" : {
            "id" : {
              "type" : "keyword"
            },
            "type" : {
              "type" : "keyword"
            },
            "name" : {
              "type" : "keyword"
            },
            "additionalType": {
              "type": "keyword"
            },
            "subOrganization": {
              "properties" : {
                "id" : {
                  "type" : "keyword"
                },
                "type" : {
                  "type" : "keyword"
                },
                "name" : {
                  "type" : "keyword"
                },
                "additionalType": {
                  "type": "keyword"
                }
              }
            }
          }
        },
        "type": {
          "type" : "keyword"
        },
        "keywords" : {
          "type" : "text",
          "fields" : {
            "keyword" : {
              "type" : "keyword"
            }
          }
        },
        "hasCourseInstance": {
          "properties": {
            "courseMode": {
              "type": "keyword"
            },
            "courseWorkload": {
              "type": "text"
            },
            "location": {
              "type": "text"
            },
            "startDate" : {
              "type" : "date",
              "index" : true
            },
            "endDate" : {
              "type" : "date",
              "index" : true
            },
            "instructor": {
              "properties" : {
                "id" : {
                  "type" : "keyword"
                },
                "name" : {
                  "type" : "text",
                  "fields" : {
                    "keyword" : {
                      "type" : "keyword"
                    }
                  }
                },
                "type" : {
                  "type" : "keyword"
                },
                "honorificPrefix": {
                  "type": "text"
                }
              }            
            }
          }
        },
        "institutions" : {
          "properties" : {
            "id" : {
              "type" : "keyword"
            },
            "type" : {
              "type" : "keyword"
            },
            "name" : {
              "type" : "keyword"
            },
            "location": {
              "properties": {
                "geo": {
                  "type": "geo_point"
                },
                "address": {
                  "properties": {
                    "addressCountry": {
                      "type" : "keyword"
                    },
                    "addressLocality": {
                      "type" : "text",
                      "fields" : {
                        "keyword" : {
                          "type" : "keyword"
                        }
                      }
                    },
                    "addressRegion": {
                      "type" : "text",
                      "fields" : {
                        "keyword" : {
                          "type" : "keyword"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}